################################################################################
################################################################################
################################################################################

''' ATTENZIONE!!! INSERITE QUI SOTTO IL VOSTRO NOME, COGNOME E MATRICOLA '''

nome        = "NOME"
cognome     = "COGNOME"
matricola   = "MATRICOLA"

################################################################################
################################################################################
################################################################################

import albero
def es2(tree):
    '''
    Es 2: ? punti
    Si definisca la funzione es2(tree) ricorsiva (o che fa uso di funzioni o metodi ricorsive/i) che:
    - riceve come argomento 'tree' un  albero  formato da nodi di tipo
      AlberoBinario definito nella libreria albero.py allegata
    - calcola il numero di nodi che nell'albero hanno ESATTAMENTE due figli
    - torna come risultato il numero calcolato
    Esempio: se l'albero e':

             7
            /\
           1  3
          / \
        4    6
       /    /
      5    2
     /     \
    9       8

Nell'albero ci sono solo due nodi con esattamente due figli (il nodo con valore 7 ed il nodo
con valore 1) cosi'  la funzione tornera' il valore 2.
    '''
    # inserisci qui il tuo codice

#############################################################################

import immagini
def es3(fimm1,fimm2,fimm3):
    '''    
    Es 3: 6 punti
    Si definisca la  funzione es3(fimm1,fimm2,fimm3) che, 
    - riceve gli  indirizzi di due file .PNG da leggere (fimm1 e fimm2) e l'indirizzo 
      di un file (fimm3) da creare.
    - legge le due immagini e crea la terza immagine da salvare all'indirizzo fimm3. 
      La terza immagine si ottiene dalle prime due. Ha ampiezza  minima tra 
      le ampiezze  di fimm1 e fimm2 ed  altezza minima tra le altezze di fimm1 e fimm2.
      il pixel [i][j] dell'immagine ha lo stesso colore del pixel corrispondente
      dell'immagine fimm1 se i e j sono entrambi numeri pari o entrambi numeri dispari, 
      ha il colore del pixel corrispondente in  fimm2 altrimenti
    - salva l'immagine creata all'indirizzo fimm3
    - calcola  il numero di pixel presenti nell'immagine creata per i quali  la somma delle 
      tre coordinate del colore e' un numero dispari.
      - restituisce il valore calcolato
    Per caricare e salvare i file PNG si possono usare load e save della libreria immagini.
    '''
    # inserisci qui il tuo codice

#############################################################################

def es5(s,k):
    '''
    Es 5: 3 punti
    progettare la funzione es5(s,k) che: 
    - riceve  in input una stringa s di caratteri che sono le cifre da  '0' a '9'  ed un intero k 
    - costruisce la lista con  le diverse sottostringhe  di s  i cui caratteri sono in 
      ordine strattamente crescente.
    - restituisce la lista dopo averne ordinato gli elementi in ordine decrescente
   Nota che la lista non deve contenere duplicati. 
   Si ricorda che una sottostringa di s e' quello che si ottiene da s eliminando 0 o piu' 
   caratteri iniziali  e 0 o piu' caratteri finali.
   ESEMPI: 
   con  s='9135918246556' e k=3 la funzione restituisce la lista ['359','246', 135']
   con  s='1234123412341234' e k=3 la funzione restituisce la lista ['234',123']
   con  s='987654321' e k=3 la funzione restituisce la lista []
    '''
    # inserisci qui il tuo codice

##########################################################################################

def es7(ls, c):
    '''
    Es 7: 3 punti 
    progettare la funzione es7(ls,c) che: 
    - riceve  in input una lista di parole ls ed un carattere c
    - cancella da ls le parole che contengono il carattere c (sia in maiuscolo che in minuscolo)
    - restituisce il numero di parole cancellate da ls. 
    Nota che al termine della funzione la lista passata come parametro deve risultare modificata
    (ricorda che le liste sono mutabili). 
     ESEMPI:
     Se ls=[ 'Angelo', 'Andrea', 'Fabio', 'Francesco', 'Lucio','Luca', 'Ugo'] e c='a'
     la funzione restituisce 5 e la lista ls diventa ['Lucio','Ugo']  
     Se ls=[ 'Angelo', 'Andrea', 'Fabio', 'Francesco', 'Lucio', 'Luca','Ugo'] e c='G'
     la funzione restituisce 2 e la lista ls diventa ['Andrea', 'Fabio', 'Francesco', 'Lucio','Luca']
    '''
    # inserisci qui il tuo codice.

#############################################################################

# Una matrice si dice sparsa se ha pochi valori diversi da zero. Per risparmiare spazio 
# di memoria, anzicche' utilizzare liste di liste  possiamo rappresentare matrici 
# sparse tramite dizionari. Il dizionario di una matrice sparsa M ha come chiavi delle tuple  
# e come attributo degli interi. Le tuple sono coppie e la coppia (i,j) e' presente nel dizionario 
# se e solo se M[i][j] e' diverso  da zero. L'attributo della chiave (i,j) sara' poi proprio M[i][j].
# ad ESEMPIO il dizionario 
# d={(0,2): 4,(1,0): 1, (1,1): 2, (2,1):8 } rappresenta la matrice quadrata  M=
# | 0 0 4 |
# | 1 2 0 |
# | 0 8 0 |

def es9(d1,d2):
    '''
    Es 9: 6 punti
    Si definisca la  funzione es9(d1,d2) che, 
    - riceve due dizionari di matrici sparse della stessa dimenzione.
    - restituisce un dizionario con la matrice sparsa somma delle due matrici avute in input.
    Ad ESEMPIO se
    d1={(0,2): 4,(1,0): 1, (1,1): 2, (2,1):8 } e d2={(0,0): 5,(1,1): 2, (2,2): 5, (1,0):2 }
    allora la funzione restituira' il dizionario 
    {(0,2): 4,(1,0): 3, (1,1): 4, (2,1):8, (0,0):5, (2,2):5 }
    I dizionari ricevuti non devono essere modificati
    '''
    # inserisci qui il tuo codice

#############################################################################

def es10(ftesto):
    '''
    Es 10: 6 punti
    Si definisca la  funzione es10(ftesto) che, 
    - riceve l'indirizzo di un file di testo.
    - restituisce un dizionario con chiavi degli interi e attributi delle liste di interi.
    Il dizionario da restituire e' contenuto all'interno del file di testo dove e' presente 
    una sequenza di interi 
    inframmezzata da un numero arbitrario di spazi (' '), andate a capo ('\n') e due punti (':').
    Le chiavi del dizionario sono seguite da sempre dai ':' e poi dagli elementi della lista attributo.
    ESEMPI:
    se il file contiene il testo
    '' 
    3 : 3 6 9
    2: 4 6 10
    ''
    la funzione restituira' il dizionario { 3: [3,6,9], 2: [4,6,10]}
    Se il file contiene 
    ''     4: 5 6: 7        8 
    9 10 11:12 13:14 
    15'' 
    la funzione restituira' il dizionario {4:[5], 6:[7,8,9,10], 11:[12], 13:[14,15]}
    '''
    # inserisci qui il tuo codice


#############################################################################
